<?php

class User {

    public $id;
    public $name;
    public $username;
    public $email;
    public $phone;
    public $isDriver;

    public static function Create($id, PDO $conn) {
        try {
            $stmt = $conn->prepare("SELECT * FROM user WHERE id=$id");
            $stmt->execute();

            $stmt->setFetchMode(PDO::FETCH_ASSOC);
            $user = $stmt->fetchObject();
            $result = new User($user->id, $user->name, $user->username, $user->email, $user->phone);
            $result->isDriver = $user->is_driver;

            return $result;
        } catch (PDOException $e) {
            echo "Error : ".$e->getMessage();
            return false;
        }
    }

    public static function GetAllUsers(PDO $conn) {
        try {
            $result = $conn->query("SELECT * FROM user")->fetchAll();
            return $result;

        } catch (PDOException $e) {
            echo "Error: ".$e->getMessage();
            return false;
        }
    }

    public static function GetAllUsernameAndPassword(PDO $conn) {
        try {
            $users = $conn->query("SELECT username, password FROM user")->fetchAll();
            foreach ($users as $record) {
                $result[$record['username']] = $record['password'];
            }
            return $result;
        } catch (PDOException $e) {
            echo "Error: ".$e->getMessage();
            return false;
        }
    }

    public static function GetUserById($id, PDO $conn) {
        try {
            $stmt = $conn->prepare("SELECT * FROM user WHERE id=?");
            $stmt->execute([$id]);

            $user = $stmt->fetchObject();
            return $user;
        } catch (PDOException $e) {
            echo "Error: ".$e->getMessage();
            return false;
        }
    }

    public static function GetUserBy($attribute, $value, PDO $conn) {
        try {
            $stmt = $conn->prepare("SELECT * FROM user WHERE $attribute='$value'");
            $stmt->execute();

            $user = $stmt->fetchObject();
            return $user;
        } catch (PDOException $e) {
            echo "Error: ".$e->getMessage();
            return false;
        }
    }

    public static function UpdateUser($user, PDO $conn) {
        try {
            if ($user instanceof User) {
                $newAttributes = "";
                $newAttributes .= "name = "."$user->name, ";
                $newAttributes .= "email = "."$user->email, ";
                $newAttributes .= "phone = "."$user->phone, ";
                $newAttributes .= "is_driver = "."$user->isDriver";

                $conn->prepare("UPDATE user SET $newAttributes WHERE id =?")->execute([$user->id]);
            }
        } catch (PDOException $e) {
            echo "Error: ".$e->getMessage();
            return false;
        }
    }

    public static function InsertUser($user, PDO $conn) {
        try {
            $lastUser = $conn->query("SELECT * FROM user ORDER BY id DESC LIMIT 1")->fetch(PDO::FETCH_ASSOC);
            $newId = $lastUser['id'] + 1;
            $values = "";
            $columns = "";

            foreach ($user as $key => $attr) {
                if ($key !== "id" && $key !== "is_driver") {
                    $columns .= $key.",";
                    $values .= "'$attr'".",";
                } else if ($key === "is_driver") {
                    $columns .= $key;
                    $values .= $attr;
                }
            }
            $columns = "id,".$columns;
            $values = $newId.",".$values;

            $insertExpression = "INSERT INTO user ($columns) VALUES ($values)";

            $conn->query($insertExpression);
        } catch (PDOException $e) {
            echo "Error: ".$e->getMessage();
            return false;
        }
    }

}